<template>
    <div class="row justify-center q-pa-lg">
        <div class="col-5">
            <q-card flat bordered>
                <q-item>
                    <q-item-section avatar>
                        <q-avatar v-if="subcontractor != null" :style="`background: ${subcontractor.principal.color}`" size="64px">
                            <img :src="subcontractor.principal.logo" :alt="Avatar" style="width: 48px; height: 50px;" class="bg-base">
                        </q-avatar>
                        <q-skeleton v-else type="QAvatar"/>
                    </q-item-section>
                    <q-item-section>
                        <q-item-label v-if="subcontractor != null" class="text-h5">
                            {{ subcontractor.principal.name }}
                        </q-item-label>
                        <q-skeleton v-else type="text"/>
                        <q-item-label v-if="subcontractor != null" caption>
                            {{ subcontractor.principal.id }}
                        </q-item-label>
                        <q-skeleton v-else type="text"/>
                    </q-item-section>
                </q-item>
                <q-separator/>
                <q-item style="min-height: 300px;" class="column justify-center">
                    <MetaData v-if="subcontractor != null" :meta="subcontractor.principal.meta" class="full-width"/>
                    <q-skeleton v-else height="300px" class="full-width"/>
                </q-item>
                <q-separator/>
                <q-card-actions align="around">
                    <q-btn v-if="subcontractor != null"
                           flat label="edit" icon="edit" color="primary"
                           :to="`/subcontractor/edit/${subcontractor.principal.id}`"
                    />
                    <q-skeleton v-else type="QBtn"/>
                    <q-btn v-if="subcontractor != null"
                           outline icon="delete" label="delete" color="negative"
                           @click="$emit('delete')"
                    />
                    <q-skeleton v-else type="QBtn"/>
                </q-card-actions>
            </q-card>

        </div>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {SubContractorResponse} from "src/classLibrary/APIModels/core/subContractorResponse";
import {GenerateAvatar} from "src/classLibrary/AvatarGenerator";
import MetaData from "components/Entities/MetaData.vue";

@Component({
    components: {MetaData}
})
export default class SubContractorFullCard extends Vue {
    @Prop() subcontractor!: SubContractorResponse;
    get Avatar() {
        return GenerateAvatar(this.subcontractor?.principal.name ?? "A")
    }
}
</script>

<style lang='scss' scoped>

</style>
